This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 465664 - brp-java-repack-jars repacked jar in a way that breaks JarInputStream.getManifest
brp-java-repack-jars repacked jar in a way that breaks JarInputStream.getMani...
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: redhat-rpm-config (Show other bugs)
17
All Linux
medium Severity medium
: ---
: ---
Assigned To: Panu Matilainen
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-10-05 06:28 EDT by Robin Green
Modified: 2012-11-09 06:50 EST (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-11-09 06:50:04 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
test-case (8.97 KB, application/x-gzip)
2008-10-16 08:36 EDT, Caolan McNamara
no flags Details
demo workaround patch (540 bytes, patch)
2008-10-16 08:36 EDT, Caolan McNamara
no flags Details | Diff

  None (edit)
Description Robin Green 2008-10-05 06:28:23 EDT
Description of problem:
If I search for random topics (which appear in the Index or the Contents tabs) in the Find tab of openoffice help, it can't find any of them.

Version-Release number of selected component (if applicable):
openoffice.org-base-3.0.0-9.1.fc10.i386
openoffice.org-calc-3.0.0-9.1.fc10.i386

How reproducible:
Always

Steps to Reproduce:
1. oocalc
2. Help -> OpenOffice.org Help
3. Go to the Find tab
4. Search for something
  
Actual results:
Dialog box appears saying "No topics found"

Expected results:
Some topics should be found

Additional info:
Running rawhide inside VirtualBox 2.0.2 OSE on Mac OS X 10.5.
Comment 1 Caolan McNamara 2008-10-05 07:21:29 EDT
Bah, I bet I need to make lucene a runtime dependency of Ooo to make this work. Sigh, more java goo
Comment 2 Caolan McNamara 2008-10-06 04:40:20 EDT
Should be ok in >= 3.0.0-9.3
Comment 3 Caolan McNamara 2008-10-16 08:34:58 EDT
Hmm, that doesn't work because of a horror-story.

With the attached example:

> java test
manifest ok
> export RPM_BUILD_ROOT=`pwd`
> /usr/lib/rpm/redhat/brp-java-repack-jars
> java test
manifest broken

Where test.java is...

JarInputStream jarIn = new JarInputStream(new FileInputStream("./LuceneHelpWrapper.jar"));
Manifest manifest = jarIn.getManifest();
if (manifest == null) {
    System.err.println("manifest broken");
}
lse {
    System.err.println("manifest ok");
}

Now, as to why...

Originally we have...
# unzip -l LuceneHelpWrapper.jar 
Archive:  LuceneHelpWrapper.jar
  Length     Date   Time    Name
 --------    ----   ----    ----
      164  10-16-08 12:58   META-INF/MANIFEST.MF
        0  10-16-08 12:20   HelpLinker/
        0  10-16-08 12:58   HelpLinker/META-INF/
      164  10-16-08 12:58   HelpLinker/META-INF/MANIFEST.MF
        0  10-16-08 12:20   com/
        0  10-16-08 12:20   com/sun/
        0  10-16-08 12:20   com/sun/star/
        0  10-16-08 12:20   com/sun/star/help/
     1199  10-16-08 12:58   com/sun/star/help/HelpSearch.class
     5420  10-16-08 12:58   com/sun/star/help/HelpIndexer.class
     4520  10-16-08 12:58   com/sun/star/help/HelpSearch$_HelpSearch.class
     1827  10-16-08 12:58   com/sun/star/help/HelpFileDocument.class
 --------                   -------
    13294                   12 files

....

now post brp-java-repack-jars which is run at the end of our rpmbuild we have...

# unzip -l LuceneHelpWrapper.jar 
Archive:  LuceneHelpWrapper.jar
  Length     Date   Time    Name
 --------    ----   ----    ----
        0  01-01-80 00:00   HelpLinker/
        0  01-01-80 00:00   HelpLinker/META-INF/
      164  01-01-80 00:00   HelpLinker/META-INF/MANIFEST.MF
        0  01-01-80 00:00   META-INF/
      164  01-01-80 00:00   META-INF/MANIFEST.MF
        0  01-01-80 00:00   com/
        0  01-01-80 00:00   com/sun/
        0  01-01-80 00:00   com/sun/star/
        0  01-01-80 00:00   com/sun/star/help/
     1827  01-01-80 00:00   com/sun/star/help/HelpFileDocument.class
     5420  01-01-80 00:00   com/sun/star/help/HelpIndexer.class
     4520  01-01-80 00:00   com/sun/star/help/HelpSearch$_HelpSearch.class
     1199  01-01-80 00:00   com/sun/star/help/HelpSearch.class
 --------                   -------
    13294                   13 files

i.e. META-INF/MANIFEST.MF is no longer the first entry.
Comment 4 Caolan McNamara 2008-10-16 08:36:07 EDT
Created attachment 320548 [details]
test-case

Test case
Comment 5 Caolan McNamara 2008-10-16 08:36:57 EDT
Created attachment 320549 [details]
demo workaround patch
Comment 6 Bug Zapper 2008-11-25 22:34:28 EST
This bug appears to have been reported against 'rawhide' during the Fedora 10 development cycle.
Changing version to '10'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 7 Bug Zapper 2009-11-18 03:31:05 EST
This message is a reminder that Fedora 10 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 10.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '10'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 10's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 10 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 8 Caolan McNamara 2009-11-18 04:46:01 EST
Still in rawhide, still causes the problem. Repack is disabled in OOo spec due to this.
Comment 10 Bug Zapper 2010-03-15 08:06:13 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 13 development cycle.
Changing version to '13'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 11 Tom Hughes 2010-07-05 06:25:23 EDT
This has just bitten me as well, with packaging some plugins for a java application the repack causing java not to be able to find the manifest.
Comment 12 Bug Zapper 2011-06-02 14:27:03 EDT
This message is a reminder that Fedora 13 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 13.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '13'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 13's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 13 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 13 Robin Green 2011-06-15 12:53:41 EDT
Bug still present.
Comment 14 Robin Green 2012-07-22 02:56:54 EDT
Bug still present.
Comment 15 Fedora Update System 2012-10-03 21:06:56 EDT
redhat-rpm-config-9.1.0-34.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/redhat-rpm-config-9.1.0-34.fc18
Comment 16 Fedora Update System 2012-10-04 13:48:42 EDT
Package redhat-rpm-config-9.1.0-34.fc18:
* should fix your issue,
* was pushed to the Fedora 18 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing redhat-rpm-config-9.1.0-34.fc18'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2012-15361/redhat-rpm-config-9.1.0-34.fc18
then log in and leave karma (feedback).
Comment 17 Toshio Ernie Kuratomi 2012-11-09 06:50:04 EST
This has been pushed to F18 stable.

Note You need to log in before you can comment on or make changes to this bug.